#include <algorithm>
#include <fstream>
#include <queue>
#include <iostream>
#include <cstring>
#include <string>
#include <vector>
#include <cstdlib>

using namespace std;

char a[32][32];
int N;
int bad[32][32];
pair < int, int > d[4];
vector < pair < int, int > > v;

string getString(){
    string in;

    cin >> in;

    return in;
}

bool isNumber ( string tmp ){
    return ( tmp[0] >= '0' && tmp[0] <= '9' );
}

int toint ( string inp ){
    int res = 0;

    for ( int i = 0; i < inp.size(); ++i )
        res = res * 10 + inp[i] - '0';

    return res;
}

void scan(){
    cin >> N;

    for ( int i = 0; i < N; ++i )
        for ( int j = 0; j < N; ++j ){
            string cur = getString();

            if ( isNumber(cur) )
                a[i][j] = toint ( cur );
            else
                a[i][j] = cur[0];
        }
}

/*
int canFinish(){
    for ( int i = 0; i < N; ++i )
        for ( int j = 0; j < N; ++j )
            if ( a[i][j] <= 20 )
                if ( canFinish ( i, j ) )
                    return 1;
    return 0;
}
*/

int count ( int i, int j ){
    if ( bad[i][j] ) return -1;
    queue < pair < int, int > > q;
    int used[32][32], res = 1, expected = a[i][j];

    memset ( used, 0, sizeof ( used ) );

    used[i][j] = 1;
    q.push ( make_pair ( i, j ) );

    while ( !q.empty() ){
        i = q.front().first; j = q.front().second;
        q.pop();

        for ( int k = 0; k < 4; ++k ){
            int ni = i + d[k].first, nj = j + d[k].second;
            if ( ni < 0 || ni >= N || nj < 0 || nj >= N ) continue;

            if ( used[ni][nj] == 1 || a[ni][nj] <= 20 || bad[ni][nj] )
                continue;

            used[ni][nj] = 1;
            q.push ( make_pair ( ni, nj ) );
            ++res;
        }

        if ( res >= expected ) break;
    }

    return res;
}

void print( int i, int j ){
    int used[32][32];
    int expected = a[i][j];

    memset ( used, 0, sizeof ( used ) );
    queue < pair < int ,int > > q;

    used[i][j] = 1;
    cout << (int)a[i][j] << endl;
    cout << i << " " << j << endl;
   // cout << (int)a[i][j] << endl;
    --expected;

    q.push ( make_pair ( i, j ) );

    if ( !expected ) return;

    while ( !q.empty() ){
        i = q.front().first;
        j = q.front().second;
        q.pop();

        for ( int k = 0; k < 4; ++k ){
            int ni = i + d[k].first, nj = j + d[k].second;
            if ( ni < 0 || ni >= N || nj < 0 || nj >= N ) continue;

            if ( used[ni][nj] == 1 || a[ni][nj] <= 20 || bad[ni][nj] )
                continue;

            used[ni][nj] = 1;
            q.push ( make_pair ( ni, nj ) );
            cout << ni << " " << nj << endl;
         //   cout << (int)a[ni][nj] << endl;
            --expected;

            if ( !expected ) return;
        }
    }
}

inline int f ( pair < int, int > t1, pair < int, int > t2 ){
    return a[t1.first][t1.second] < a[t2.first][t2.second];
}

void solve(){
    for ( int i = 0; i < N; ++i )
        for ( int j = 0; j < N; ++j )
            if ( a[i][j] == 'B' ){
                for ( int k = 0; k < 4; ++k ){
                    int ni = i + d[k].first, nj = j + d[k].second;

                    if ( ni < 0 || ni >= N || nj < 0 || nj >= N ) continue;
                    bad[ni][nj] = 1;
                }
                bad[i][j] = 1;
            }
          //  else if ( a[i][j] == '#' )
            //    bad[i][j] = 1;

 /*   for ( int i = 0; i < N; ++i ){
        for ( int j = 0; j < N; ++j )
            cout << bad[i][j] << " ";
        cout << endl;
    }
        /*
    if ( N == 5 ){
        if ( canFinish() )
            return;
    }*/

    for ( int i = 0; i < N; ++i )
        for ( int j = 0; j < N; ++j )
            if ( a[i][j] <= 20 && a[i][j] )
                if ( count ( i, j ) >= a[i][j] )
                    v.push_back ( make_pair ( i, j ) );

    if ( v.size() == 0 )
        return;

    sort ( v.begin(), v.end(), f ) ;

    int idx = v.size() - 1;

    print ( v[idx].first, v[idx].second );
/*
    cout << "--------------------\n\n\n";

    for ( int i = 0; i < v.size(); ++i )
        cout << v[i].first << " " << v[i].second << endl;
*/
}

void init(){
    d[0] = make_pair ( 0, 1 );
    d[1] = make_pair ( 0, -1 );
    d[2] = make_pair ( 1, 0 );
    d[3] = make_pair (-1, 0 );
}

int main(){
    freopen ( "game.in", "r", stdin );
    freopen ( "game.out", "w", stdout );

    srand ( 22 );
    init();
    scan();

 /*   for ( int i = 0; i < N; ++i ){
        for ( int j = 0; j < N; ++j )
            cout << (int) a[i][j] << " ";
        cout << endl;
    }*/

    solve();

    return 0;
}
